#include "Map.h"

#include <string.h>

/** Constructor **/
/* Generic Constructor */
Map *new_map() {
	Map *this;
	this = (Map*) malloc( sizeof(Map) );
	strcpy(this->file_map_txt, "null");
	this->number_row = 0;
	this->number_column = 0;
	return this;
}//end new_map (generic constructor)

/* With Files in argument */
Map *new_map_with_file(char file_image_tiles[SIZE_PATH],
	char file_map_txt[SIZE_PATH],
	char file_map_operation[SIZE_PATH]
) {
 Map *this;
 this = (Map*) malloc( sizeof(Map) );
	strcpy(this->file_image_tiles, file_image_tiles);
	strcpy(this->file_map_txt, file_map_txt);
	strcpy(this->file_map_operation, file_map_operation);
	this->number_row = 0;
	this->number_column = 0;
	Map_load_map(this);
 return this;
}//end new_map_with_file (constructor)

/**
 *  Public function
 * */
void Map_display_map_console(Map *this) {
	printf("Display Map\n");
	char read='a';
	int i=0, j;
	for ( j = 0; j < this->number_row; j++) {
	while ( read != '\n' ) {
		read = this->array_map_ascii[i][j];
		printf("%c", this->array_map_ascii[i][j]);
		i++;
	}//end while
	i=0;
	read='a';
	}//end for
}//end Map_display_map_console

//void Map_display_map_SDL(Map *this, SDL_Renderer *renderer, ArrayMapCumulCost arrayMapCumulCost) {
void Map_display_map_SDL(Map *this, SDL_Renderer *renderer) {

	SDL_Surface *map_image;
	SDL_Texture *texture;
	SDL_Rect Src;
	SDL_Rect Dest;
	char read='a';
	int i_read;
	int i=0, j;
	
	Src.x = 0;
	Src.y = 0;
	Src.w = SIZE_BMP_DECOR;
	Src.h = SIZE_BMP_DECOR;
	Dest.w = SIZE_BMP_DECOR;
	Dest.h = SIZE_BMP_DECOR;
	map_image = SDL_LoadBMP(this->file_image_tiles);
	if (map_image) {
		texture = SDL_CreateTextureFromSurface(renderer, map_image);
//		SDL_SetTextureBlendMode(texture, SDL_BLENDMODE_BLEND);
//		SDL_SetTextureAlphaMod(texture, 255);
		for ( j = 0; j < this->number_row; j++) {
		while ( read != '\n' ) {
			read = this->array_map_ascii[i][j];
			i_read = read - 0;
			if ( (i_read > 31) && (i_read < 45) ) { i_read = read - 32; Src.y = 0; }
			if ( (i_read > 44) && (i_read < 58) ) { i_read = read - 45; Src.y = SIZE_BMP_DECOR; }
			if ( (i_read > 57) && (i_read < 71) ) { i_read = read - 58; Src.y = 2*SIZE_BMP_DECOR; }
			if ( (i_read > 70) && (i_read < 84) ) { i_read = read - 71; Src.y = 3*SIZE_BMP_DECOR; }
			if ( (i_read > 79) && (i_read < 97) ) { i_read = read - 84; Src.y = 4*SIZE_BMP_DECOR; }
			if ( (i_read > 96) && (i_read < 110) ) { i_read = read - 97; Src.y = 5*SIZE_BMP_DECOR; }
			if ( (i_read > 109) && (i_read < 123) ) { i_read = read - 110; Src.y = 6*SIZE_BMP_DECOR; }
			if ( (i_read > 122) && (i_read < 128) ) { i_read = read - 123; Src.y = 7*SIZE_BMP_DECOR; }

	//		printf("i_read = %i\n", i_read);
			Src.x = i_read*SIZE_BMP_DECOR;
			Dest.x = i*SIZE_BMP_DECOR;
			Dest.y = j*SIZE_BMP_DECOR;
			
//			if ((i==3) && (j==5)) {
//printf("ArrayMapCumulCost[%d][%d]=%f\n", i, j, arrayMapCumulCost[i][j]);

/*
if ( (arrayMapCumulCost[i][j] > 0) && (arrayMapCumulCost[i][j] < 8) ) {
	
	
			} else {
//				printf("Hors alpha\n");
//				SDL_SetTextureAlphaMod(texture, 255);
				SDL_SetTextureBlendMode(texture, SDL_BLENDMODE_NONE);
				SDL_RenderCopy(renderer, texture, &Src, &Dest);
			}
*/	
			
		SDL_RenderCopy(renderer, texture, &Src, &Dest);
			
	//		printf("%c", map->array_map[i][j]);
			i++;
		}//end while
		i=0;
		read='a';
		}//end for
		
//		SDL_RenderPresent(renderer);
		SDL_DestroyTexture(texture);
		SDL_FreeSurface(map_image);
	} else {
		printf("Call in Map_display_map_SDL. Error Load tiles image : %s\n", this->file_image_tiles);
	}//end if map_image
}//end Map_display_map_SDL

void Map_display_possible_displacement_SDL(Map *this, SDL_Renderer *renderer,
				ArrayMapCumulCost arrayMapCumulCost, int total_cost) {
	SDL_Surface *p_image;
	SDL_Texture *texture;
	p_image = SDL_LoadBMP(this->file_map_operation);
	if (p_image) {
		printf("Deplacement possible\n");
//		SDL_SetColorKey(p_image, SDL_TRUE, SDL_MapRGB(p_image->format, 255, 255, 255));
		texture = SDL_CreateTextureFromSurface(renderer, p_image);
		SDL_SetTextureBlendMode(texture, SDL_BLENDMODE_BLEND);
		SDL_SetTextureAlphaMod(texture, 120);
		SDL_Rect Src, Dest;
		Src.w = SIZE_BMP_DECOR;
		Src.h = SIZE_BMP_DECOR;
		Dest.w = SIZE_BMP_DECOR;
		Dest.h = SIZE_BMP_DECOR;
		Dest.x = 0;
		Dest.y = 0;
		Src.x = 32;
		Src.y = 0;
//			SDL_RenderCopy(renderer, texture, &Src, &Dest);

		for (int r=0; r<this->number_row; r++) {
			for (int c=0; c<this->number_column; c++) {
				if ( (arrayMapCumulCost[c][r] > 0) && (arrayMapCumulCost[c][r] < total_cost) ) {
					Dest.x = c*SIZE_BMP_DECOR;
					Dest.y = r*SIZE_BMP_DECOR;
					SDL_RenderCopy(renderer, texture, &Src, &Dest);
				}
			}//end for c
		}//end for r
	} else {
		printf("Problem load image in Map.c : %s\n", this->file_map_operation);
	}//endif
	SDL_DestroyTexture(texture);	
	SDL_FreeSurface(p_image);
}//end Map_display_possible_displacement_SDL

int Map_load_map(Map *this) {
	int i=0, j=0;
	char tile;
	printf("Fichier image : %s\n", this->file_image_tiles);
	printf("Fichier map : %s\n", this->file_map_txt);
	
    FILE *fileMap;
	fileMap = fopen(this->file_map_txt, "r");
	
	if (fileMap == NULL) {
		printf("In call Map_load_map\t Error Load File : %s\n", this->file_map_txt);
		exit(0);
	}

	while ( (tile=getc(fileMap)) != EOF ) {
//		printf("Caractere %i %i: %c\n", j, i, tile);
		this->array_map_ascii[i][j] = tile;
				i++;
		this->number_column++;
		if ( tile == '\n' ) { 
			j++;
			this->number_row++;
			this->number_column--; //delete return => \n
			i=0;
		}//end if \n
	}//end while !=EOF
	
    fclose(fileMap);
	this->number_column = (int)  ( this->number_column / this->number_row);
	return 1;
}//end Map_load_map

int Map_load_map_with_file(Map *this, char file_image_tiles[SIZE_PATH],  char file_map_txt[SIZE_PATH]) {
	int i=0, j=0;
	char tile;
	strcpy(this->file_image_tiles, file_image_tiles);
	strcpy(this->file_map_txt, file_map_txt);
	
	printf("Fichier image : %s\n", this->file_image_tiles);
	printf("Fichier map : %s\n", this->file_map_txt);
	
    FILE *fileMap;
	fileMap = fopen(this->file_map_txt, "r");
	
	if (fileMap == NULL) {
		printf("In call Map_load_map\t Error Load File : %s\n", this->file_map_txt);
		exit(0);
	}

	while ( (tile=getc(fileMap)) != EOF ) {
//		printf("Caractere %i %i: %c\n", j, i, tile);
		this->array_map_ascii[i][j] = tile;
				i++;
		this->number_column++;
		if ( tile == '\n' ) { 
			j++;
			this->number_row++;
			this->number_column--; //delete return => \n
			i=0;
		}//end if \n
	}//end while !=EOF
	
    fclose(fileMap);
	this->number_column = (int)  ( this->number_column / this->number_row);
	return 1;
}//end Map_load_map_with_file

void free_map(Map *this) {
	free(this);
}//end free_map
