#ifndef MAP_H
#define MAP_H

#include <stdio.h>
#include <stdlib.h>
#include <SDL2/SDL.h>

#include "Global.h"
#include "TrayMapUnit.h"

//#define SIZE_PATH 100
#define SIZE_BMP_DECOR 32
//#define SIZE_MAP 128

typedef struct {
	char file_image_tiles[SIZE_PATH];
	char file_map_txt[SIZE_PATH];
	char file_map_operation[SIZE_PATH];
//	char array_map[SIZE_MAP][SIZE_MAP];
	ArrayMapASCII array_map_ascii;
	int number_column;
	int number_row;
}Map;


Map *new_map();
Map *new_map_with_file(
	char file_image_tiles[SIZE_PATH],
	char file_map_txt[SIZE_PATH],
	char file_map_operation[SIZE_PATH]
	);
void Map_display_map_console(Map *map);
//void Map_display_map_SDL(Map *map, SDL_Renderer *renderer, ArrayMapCumulCost arrayMapCumulCost);
void Map_display_map_SDL(Map *map, SDL_Renderer *renderer);
void Map_display_possible_displacement_SDL(Map *map, SDL_Renderer *renderer,
												ArrayMapCumulCost arrayMapCumulCost, int total_cost);
int Map_load_map(Map *map);
int Map_load_map_with_file(Map *map, char file_image_tiles[SIZE_PATH], char file_map_txt[SIZE_PATH]);
void free_map(Map *map);
#endif // MAP_H
