#include "Scene.h"

Scene *new_scene(SDL_Renderer *renderer) {
	Scene *this;
	char line[100];
	char pathImage[SIZE_PATH];
	char pathSound[SIZE_PATH];
	
	this = (Scene*)  malloc(sizeof(Scene));
	
	this->renderer = renderer;
	
	if(Mix_OpenAudio(44100,MIX_DEFAULT_FORMAT,2,1024)<0) {
		printf("Erreur %s\n", Mix_GetError());
	}
	/* Init sound */
	Mix_AllocateChannels(1);
	Mix_Chunk *soundSelect;
	soundSelect = Mix_LoadWAV("../sound/select2.wav");
	if (!soundSelect) {
		printf("Error in Scene_change_select (Mix_LoadWAV) : %s\n", Mix_GetError());
		exit(0);
	} else {
		printf("Select sound\n");
	}
	this->soundSelect = soundSelect;
	Mix_Chunk *soundUnit;

} //end new_scene

/*
 * If new unit is selected
 * change image select, calcul new cost
 * */
void Scene_change_select_unit(Scene *this, int numberSelectedUnit, int x, int y){
	int i;
	int X = (int) (x/SIZE_BMP_DECOR);
	int Y = (int) (y/SIZE_BMP_DECOR);
	Mix_PlayChannel(0, this->soundSelect, 0);
	printf("Old unit : %d \t New unit : %d\n", this->numberBeforeLastSelectedUnit, numberSelectedUnit);

	this->unit[this->numberBeforeLastSelectedUnit]->state = IMMOBILE;
	this->unit[numberSelectedUnit]->state = SELECTED;
	this->numberBeforeLastSelectedUnit = numberSelectedUnit;
	this->numberLastSelectedUnit = numberSelectedUnit;
	printf("X=%d\tY=%d\n", X, Y);

//	Scene_display_select_unit(this);
	Unit_display_cost_unit(this->unit[numberSelectedUnit]);
	Tray_set_cost(this->tray, this->unit[numberSelectedUnit]->costGround);
	Tray_calcul_cost_starting_position(this->tray, X, Y);

	Tray_display_cost_ground(this->tray);
	Tray_display_cumul_cost(this->tray);

		Map_display_map_SDL(this->map, this->renderer);

	for (i=0; i < this->totalNumberUnit; i++) {
		Unit_display_unit_SDL(this->unit[i], this->renderer);
	}//end for
	
		Map_display_possible_displacement_SDL(
			this->map, this->renderer,
			this->tray->arrayMapCumulCost,
			this->unit[numberSelectedUnit]->costGround.total_cost);

//	printf("Test dans Scene_select_unit ->TrayMapUnit_dsplay_array_map_cumul_cost()\n");
//	printf("Valeur au hasard [%d][%d]=%f\n", 3, 5, this->tray->arrayMapCumulCost[3][5]);
	TrayMapUnit_display_array_map_cumul_cost(this->tray->arrayMapCumulCost,
							this->map->number_column, this->map->number_row);
	
	SDL_RenderPresent(this->renderer);
	Tray_reset(this->tray);
}//end Scene_change_select_unit


void Scene_display_files(Scene *this) {
	printf("FILE_MAP_BMP : %s\n", this->pathMapBMP);
	printf("FILE_MAP_ASCII : %s\n", this->pathMapASCII);
	printf("FILE_UNIT : %s\n", this->pathUnit);
}

void Scene_display_select_unit(Scene *this) {
	int i=0;
	for (i=0; i < this->totalNumberUnit; i++) {
		printf("Unit[%i] is %i\n", i, this->unit[i]->state);
	}
}

void Scene_load_scene( Scene *this, char _file_scenario[SIZE_PATH] ) {
	int i;
	char line[200];
	strcpy(this->file_scenario, _file_scenario);
	char typeFile[100];
	char pathFile[100];
	
	FILE *fileScenario;
	fileScenario = fopen(this->file_scenario, "r");
	
	if (fileScenario == NULL) {
		printf("In call Scene_load_scene\t Error Load File : %s\n", this->file_scenario);
		exit(0);
	}
	
	while ( fgets(line, 200, fileScenario) != NULL ) {
		sscanf(line, "%s %s", typeFile, pathFile);
		if ( strcmp(typeFile, "FILE_MAP_BMP") == 0 ) {
			if (sizeof(typeFile) >= SIZE_PATH) {
				printf("Error Scene_load_scene: size of path is too big\n");
			} else {
				strcpy(this->pathMapBMP, pathFile);
			}
		}
		if ( strcmp(typeFile, "FILE_MAP_ASCII") == 0 ) {
			strcpy(this->pathMapASCII, pathFile);
		}
		if ( strcmp(typeFile, "FILE_MAP_BMP_OPERATION") == 0 ) {
			strcpy(this->pathMapBMPOperation, pathFile);
		}
		if ( strcmp(typeFile, "FILE_UNIT") == 0 ) {
			strcpy(this->pathUnit, pathFile);
		}
	}//end while
	
	Scene_display_files(this);
	
	FILE *fileUnit;
	fileUnit = fopen(this->pathUnit, "r");
	if ( fileUnit == NULL ) {
		printf("Error in load_scene : problem fileUnit\n");
		exit (0);
	} else {
		printf("Load fileUnit : %s\n", this->pathUnit);
	}
	
	/* Initialization unit's scene */
	printf("Init Unit Scene\n");
	this->totalNumberUnit = 0;
	this->numberBeforeLastSelectedUnit = 0;
	this->numberLastSelectedUnit = 0;
	this->unit[0]->state = SELECTED;

	/* Init Map and Tray */
	this->map = new_map_with_file(this->pathMapBMP, this->pathMapASCII, this->pathMapBMPOperation);
	printf("column : %i\tline : %i\n", this->map->number_column, this->map->number_row);
	this->tray = new_tray(this->map->array_map_ascii, this->map->number_column, this->map->number_row);
	
	Tray_display_ground(this->tray);
	
//		Map_display_map_SDL(this->map, this->renderer, this->tray->arrayMapCumulCost);
		Map_display_map_SDL(this->map, this->renderer);

	i=0;
	while ( fgets( line, 200, fileUnit) != NULL ) {
		printf("new_scene : in fgets fileUnit -> read unit\n");
		if ( line[0] != '#' && line[0] != '\n' ) { // if no comment and no line return
			this->unit[i] = new_unit();
			sscanf(line, "%s %s %i %i %i %i %i %i %i",
					this->unit[i]->imageBMP, this->unit[i]->soundWAV,
					&this->unit[i]->column, &this->unit[i]->line,
					&this->unit[i]->costGround.earth, &this->unit[i]->costGround.mountain,
					&this->unit[i]->costGround.swamp, &this->unit[i]->costGround.water,
					&this->unit[i]->costGround.total_cost
			);
				
			this->unit[i]->costGround.obstacle = 0;	
			this->tray->rectangle[this->unit[i]->column][this->unit[i]->line].state_unit = PAUSE;
			this->unit[i]->x = this->unit[i]->column*SIZE_UNIT_BMP;
			this->unit[i]->y = this->unit[i]->line*SIZE_UNIT_BMP;
/*			
			printf("%s %s %i %i %i %i %i %i\n", this->unit[i]->imageBMP, this->unit[i]->soundWAV,
				this->unit[i]->x,
				this->unit[i]->y,
				this->unit[i]->column, this->unit[i]->line,
				this->unit[i]->costGround.earth, this->unit[i]->costGround.mountain,
				this->unit[i]->costGround.swamp, this->unit[i]->costGround.water);
*/	
				Unit_display_unit_SDL(this->unit[i], this->renderer);
			i++;
			printf("Unite i=%i chargee\n", i);
		} else  {
			printf("Is comment\n");
		}//end if not comment
//		printf("\n");
	}//end while
		
//	this->numberSelectedUnit = 0;
	this->totalNumberUnit = i;
	fclose(fileUnit);

//Tray_calcul_cost_starting_position(this->tray, this->unit[0]->column, this->unit[0]->line);
//	Map_display_map_SDL(this->map, this->renderer);
}//end Scene_load_scene

/* Return number unit who is selected or -1 if there isn't unit */
int Scene_is_unit(Scene *this, int mouse_x, int mouse_y) {
	int i, col_mouse, line_mouse;
	int result = -1;
	
	col_mouse = (int) (mouse_x/SIZE_BMP_DECOR);
	line_mouse = (int) (mouse_y/SIZE_BMP_DECOR);
	
	for (i=0; i< this->totalNumberUnit; i++) {
		if ( (col_mouse == this->unit[i]->column) && (line_mouse == this->unit[i]->line)) {
			result=i;
		}
	}
	return result;
}//end Scene_is_unit

//void Scene_set_number_unit_selected(Scene *scene, int numberSelectedUnit) {}

void free_scene(Scene *this) {
	Mix_FreeChunk(this->soundSelect);
	free_map(this->map);
	free(this);
}
