#ifndef SCENE_H
#define SCENE_H

#include <SDL2/SDL_mixer.h>

#include "../src/Global.h"
#include "../src/TrayMapUnit.h"
#include "../src/Map.h"
#include "../src/Unit.h"
#include "../src/Tray.h"

#define NB_MAX_UNIT 20
#define NB_MAX_BMP 10

typedef Unit *ListUnit[NB_MAX_UNIT];

typedef struct {
	ListUnit unit;
	int totalNumberUnit;
	int numberBeforeLastSelectedUnit;
	int numberLastSelectedUnit;
	char pathUnit[SIZE_PATH];
	char pathMapBMP[SIZE_PATH];
	char pathMapASCII[SIZE_PATH];
	char pathMapBMPOperation[SIZE_PATH];
	char file_scenario[SIZE_PATH];
	Mix_Chunk *soundSelect;
	Mix_Chunk *soundUnit;
	Map *map;
	Tray *tray;
	SDL_Renderer *renderer;
}Scene;

Scene *new_scene(SDL_Renderer *renderer);

void Scene_change_select_unit(Scene *scene, int numberSelectedUnit, int x, int y);
void Scene_display_files(Scene *scene);
void Scene_display_select_unit(Scene *scene);
void Scene_load_scene(Scene *scene, char _file_scenario[SIZE_PATH]);
int Scene_is_unit(Scene *scene, int mous_x, int mouse_y);
void free_scene(Scene *scene);
#endif //SCENE_H
