#include "Tray.h"

/**
 * Constructor
 * struct ArrayMap is defined int TrayMapUnit.h
 * */
Tray *new_tray(ArrayMapASCII array_map_ascii, int _columns, int _rows)//, CostGround costGround)
{
	int i,j;
	char read='a';
	int i_read;
	
	//	Create object Tray
	Tray *this;
	this = (Tray*) malloc(sizeof(Tray));

	// Init cost ground by default
	CostGround cost_ground;
	cost_ground.obstacle = 0;
	cost_ground.earth = 1;
	cost_ground.mountain = 2;
	cost_ground.swamp = 2;
	cost_ground.water = 0;
	cost_ground.total_cost = 10;
	Tray_set_cost(this, cost_ground);
	
	this->rectangle = (Rectangle**) malloc( _columns * sizeof(Rectangle*) );
	for (i=0; i < _columns; i++)
	{
		this->rectangle[i] = (Rectangle*) malloc( _rows * sizeof(Rectangle) );
	}
printf("Tray : col=%d \t line=%d\n", _columns, _rows);
	//	Init	Tray Object	
	this->columns = _columns;
	this->rows = _rows;
	this->lengthOfWay = 1;
//	tray->path.lengthOfWay = 1;
	for (i=0; i < _columns; i++)
	{
		for (j=0; j < _rows; j++)
		{
//			tray->rectangle[i][j].unit = NO_UNIT;
			read = array_map_ascii[i][j];
			i_read = read - 0;
			if ( (i_read > 31) && (i_read < 45) ) {
				this->rectangle[i][j].ground = OBSTACLE;
//				this->rectangle[i][j].cost = costGround.obstacle;
//				printf("obstacle : %d\n", costGround.obstacle);
				}
			if ( (i_read > 44) && (i_read < 71) ) {
				this->rectangle[i][j].ground = MOUNTAIN;
//				this->rectangle[i][j].cost = costGround.mountain;
//				printf("montagne : %d\n", costGround.mountain);
				}
			if ( (i_read > 70) && (i_read < 97) ) {
				this->rectangle[i][j].ground = EARTH;
//				this->rectangle[i][j].cost = costGround.earth;
				}
			if ( (i_read > 96) && (i_read < 110) ) {
				this->rectangle[i][j].ground = SWAMP;
//				this->rectangle[i][j].cost = costGround.swamp;
				}
			if ( (i_read > 111) && (i_read < 124) ) {
				this->rectangle[i][j].ground = WATER;
//				this->rectangle[i][j].cost = costGround.water;
				}
						
			this->rectangle[i][j].target = NOTHING;
//			this->rectangle[i][j].cost = 1;
			this->rectangle[i][j].cumul_cost =0;
//			this->rectangle[i][j].way = 0;
			this->rectangle[i][j].state_unit = NO_UNIT;
			this->arrayMapCumulCost[i][j] = 0;
		}
	}
		
	for (i=0;i<40;i++) {
		this->pathResult[i].column = 0;
		this->pathResult[i].row = 0;
	}
	Tray_reset(this);
	return this;
}//end Tray

/*************************************************/
/**			Private function					**/
/*************************************************/
static void Tray_reset_cumul_cost(Tray *this) {
	int r,c;
	for (r=0;r<this->rows;r++) {
		for (c=0;c<this->columns;c++) {
			this->rectangle[c][r].cumul_cost = 0;
			this->arrayMapCumulCost[c][r] = 0;
		}
	}
}//end Tray_reset_cumul_cost

/** Recursive algorithm of Dijkstra **/
static int Tray_calcul_cumul_cost_nearby(Tray *this, int column, int row) {
	int i, j;
	if (column < 0 || row < 0 || column > (this->columns-1) || row > (this->rows-1))
	{
		printf("Error call function - Tray_calcul_cumul_cost_nearby() -\n");
		printf("Une ligne et/ou une colonne passee en argument deborde du damier!\n");
		return -1;
	}
	
	for (i=-1; i<=+1; i++) {
		for (j=-1; j<=+1; j++) {
			if ( (i == 0) && (j == 0) )
			/*IF_1*/
			{/* nothing, is current position */}
			else {
				if (column+i <0	|| row+j<0 ||
					column+i > (this->columns-1) ||
					row+j > (this->rows-1)		)
				/*If_2*/
				{/* out of map */
//				printf("Pas de voisin pour [%i][%i]\n",column+i,row+j);
					// limite de la carte
				} else {
					if ( this->rectangle[column+i][row+j].cost == 0 )
					/* ground is obstacle or not accessible for this unit */
					/*IF_3*/
					{
//						printf("Cost vaut 0\n");
						this->rectangle[column+i][row+j].cumul_cost = -1;
						this->arrayMapCumulCost[column+i][row+j] = -1;
					} else {
						if (i==0 || j==0) //on est pas en diagonale donc cout normal
						/*IF_4*/
						{
							if (	(this->rectangle[column+i][row+j].cumul_cost) >
									(this->rectangle[column][row].cumul_cost +
										this->rectangle[column+i][row+j].cost)	||
									this->rectangle[column+i][row+j].cumul_cost == 0 )
								/*If_5*/
								{
								this->rectangle[column+i][row+j].cumul_cost =
									this->rectangle[column][row].cumul_cost
									+ this->rectangle[column+i][row+j].cost;
									
								this->arrayMapCumulCost[column+i][row+j] =
									this->rectangle[column+i][row+j].cumul_cost;
									
//	printf("Test cumul cost : %3.1f\n", this->arrayMapCumulCost[column+i][row+j]);
//	printf("Test mais avec rect : %3.1f\n", this->rectangle[column+i][row+j].cumul_cost);						
								Tray_calcul_cumul_cost_nearby(this, column+i, row+j);
								}/*EndIf_5*/
						}
						else //on est en diagonale donc cout*1,4 (=sqrt(2))
						{
							if (	(this->rectangle[column+i][row+j].cumul_cost) >
									(this->rectangle[column][row].cumul_cost +
										this->rectangle[column+i][row+j].cost)	||
									this->rectangle[column+i][row+j].cumul_cost == 0 )
								/*If_6*/
								{
								this->rectangle[column+i][row+j].cumul_cost =
									this->rectangle[column][row].cumul_cost
									+ 1.4*this->rectangle[column+i][row+j].cost;
									
								this->arrayMapCumulCost[column+i][row+j] =
									this->rectangle[column][row].cumul_cost
									+ 1.4*this->rectangle[column+i][row+j].cost;
									
								Tray_calcul_cumul_cost_nearby(this, column+i, row+j);
								}/*EndIf_6*/
						}//END_IF_4
					}//END_IF_3					
				}//END_IF_2
			}//END_IF_1
		}//end for j
	}//end for i
	return 1;
}//end Tray_calcul_cumul_cost_nearby

static int Tray_calcul_cumul_cost_nearby_old(Tray *this, int column, int row) {
	int i, j;
	if (column < 0 || row < 0 || column > (this->columns-1) || row > (this->rows-1))
	{
		printf("Error call function - Tray_calcul_cumul_cost_nearby() -\n");
		printf("Une ligne et/ou une colonne passee en argument deborde du damier!\n");
		return -1;
	}
	
	for (i=-1; i<=+1; i++)
	{
		for (j=-1; j<=+1; j++)
		{
			if ( (i == 0) && (j ==0 ) ) 
			/*If_1*/
			{/* nothing */}
			else
			{
				if (	column+i <0	|| row+j<0	||
					column+i > (this->columns-1)	||
					row+j > (this->rows-1)		)
				/*If_2*/
				{	
//				printf("Pas de voisin pour [%i][%i]\n",column+i,row+j);
					// limite de la carte
				}
				else
				{
					if (
						(this->rectangle[column+i][row+j].ground == OBSTACLE)
					/*
						(this->rectangle[column+i][row+j].ground == MOUNTAIN) || 
						(this->rectangle[column+i][row+j].ground == WATER) ||
						( this->rectangle[column+i][row+j].unit == PAUSE ) 
						*/
					)
					/*If_3*/
					{
					this->rectangle[column+i][row+j].cumul_cost = -1;
//					printf("OBSTACLE :Cout cumulé de [%i][%i] : %i\n",
//						column+i, row+j,
//						tray->rectangle[column+i][row+j].cumul_cost);	
					}
					else
					{
				//		if ( tray->rectangle[column][row].unit != PAUSE) {
						/* IF != PAUSE */
							if (i == 0 || j == 0) // on est pas en diagonale donc cout normal
							  /*If_4*/
							  {	
								if (	(this->rectangle[column+i][row+j].cumul_cost) >
									(this->rectangle[column][row].cumul_cost +
										this->rectangle[column+i][row+j].cost)	||
									this->rectangle[column+i][row+j].cumul_cost == 0 )
								/*If_5*/
								{
								this->rectangle[column+i][row+j].cumul_cost =
									this->rectangle[column][row].cumul_cost
									+ this->rectangle[column+i][row+j].cost;
								Tray_calcul_cumul_cost_nearby(this, column+i, row+j);
								}/*EndIf_5*/
							  }/*EndIf_4*/
							  else	// on est en diagonale donc cout * 1,4
							  {
								if (	(this->rectangle[column+i][row+j].cumul_cost) >
									(this->rectangle[column][row].cumul_cost +
										this->rectangle[column+i][row+j].cost)	||
									this->rectangle[column+i][row+j].cumul_cost == 0 )
								/*If_6*/
								{
								this->rectangle[column+i][row+j].cumul_cost =
									this->rectangle[column][row].cumul_cost
									+ 1.4*this->rectangle[column+i][row+j].cost;
								Tray_calcul_cumul_cost_nearby(this, column+i, row+j);
								}/*EndIf_6*/
							}
					//	}/*END_IF != PAUSE*/
					}/*EndIf_3*/
				}/*EndIf_2*/
			}/*EndIf_1*/
		}/*EndFor*/
	}/*EndFor*/
	return 1;
}//end Tray_calcul_cumul_cost_nearby_old

/*************************************************/
/**			Public function						**/
/*************************************************/
// Must be call after starting_position
int Tray_calcul_cost_arrival_position(Tray *this, int column, int row) {
	return 0;
}

// Must be call before arrival_position
void Tray_calcul_cost_starting_position(Tray *this, int column, int row) {
	printf("\nCalcul des couts de toute la carte a partir de la position de depart\n");
//	Tray_reset(this);
	Tray_reset_cumul_cost(this);
	this->lengthOfWay = 1;
	this->rectangle[column][row].way = 1;
	this->rectangle[column][row].target = BEGIN_POSITION;
	this->rectangle[column][row].cumul_cost = this->rectangle[column][row].cost;
	int res = Tray_calcul_cumul_cost_nearby(this, column, row);
}//end Tray_calcul_cost_starting_position

void Tray_display_ground(Tray *this) {
	int i,j;
	int flag = 0;
	char c;
	printf("\nAffichage du type de sol :\n");
	printf("Signification O:obstacle E:terre M:montagne S:marais W:eau\n");
	for (i=0; i < this->rows; i++)
	{
		for (j=0; j < this->columns; j++)
		{
			if ( this->rectangle[j][i].ground == OBSTACLE )
				{	c='O';	}
			if ( this->rectangle[j][i].ground == EARTH )
				{	c='E';	}
			if ( this->rectangle[j][i].ground == MOUNTAIN )
				{	c='M';	}
			if ( this->rectangle[j][i].ground == SWAMP )
				{	c='S';	}
			if ( this->rectangle[j][i].ground == WATER )
				{	c='W';	}
			if ( flag == i )
				{	printf(" %c",c);	}
			else	{	printf("\n %c",c);	}
			flag = i;
		}
	}
	printf("\n");
}//end Tray_display_ground

void Tray_display_cost_ground(Tray *this) {
	int i,j;
	int flag=0;
	printf("\nAffichage des couts de l'unite selon le type de sol :\n");
	for (i=0; i < this->rows; i++) {
		for (j=0; j < this->columns; j++) {
			if ( flag == i )
				{ printf("  %.1f", this->rectangle[j][i].cost); }
			else { printf("\n  %.1f", this->rectangle[j][i].cost); }
			flag = i;
		}
	}
	printf("\n");
}//end Tray_display_cost_ground

void Tray_display_cumul_cost(Tray *this) {
	int i,j;
	int flag=0;
	printf("\nAffichage des cumul_cost :\n");
	printf("rows : %d \t columns : %d\n", this->rows, this->columns);
	for (i=0; i < this->rows; i++)
	{
		for (j=0; j < this->columns; j++)
		{
			if (flag == i) // different end of line
				{
					if (this->rectangle[j][i].cumul_cost == -1)
						printf("%3.1f ", this->rectangle[j][i].cumul_cost);
					if (this->rectangle[j][i].cumul_cost >= 0 &&
							this->rectangle[j][i].cumul_cost < 10)
						printf("%3.1f  ", this->rectangle[j][i].cumul_cost);
					if (this->rectangle[j][i].cumul_cost >= 10)
						printf("%3.1f ", this->rectangle[j][i].cumul_cost);
				}
			else
				{
					if (this->rectangle[j][i].cumul_cost == -1) printf("\n%3.1f ", this->rectangle[j][i].cumul_cost);
					if (this->rectangle[j][i].cumul_cost >= 0 &&
					this->rectangle[j][i].cumul_cost < 10) printf("\n%3.1f  ", this->rectangle[j][i].cumul_cost);
					if (this->rectangle[j][i].cumul_cost >= 10) printf("\n%3.1f ", this->rectangle[j][i].cumul_cost);	
	//			printf("\n%3.1f ", this->rectangle[j][i].cumul_cost);
				}
			flag = i;
		}
	}
//	printf("End Tray_display_cumul_cost()");
	printf("\n");
}//end Tray_display_cumul_cost

void Tray_reset(Tray *this) {
	int i,j;
	for (i=0; i<this->columns;i++) {
		for (j=0; j < this->rows;j++) {
			this->rectangle[i][j].target = NOTHING;
			this->rectangle[i][j].cost = 1;
			this->rectangle[i][j].cumul_cost = 0;
			this->rectangle[i][j].way = 0;
		}
	}
}//end Tray_reset

void Tray_set_cost(Tray *this, CostGround costGround)
{
	int i,j;
	for (i=0; i < this->columns; i++)
	{
		for (j=0; j < this->rows; j++)
		{
			switch (this->rectangle[i][j].ground)
			{
				case OBSTACLE:
					this->rectangle[i][j].cost = costGround.obstacle;
					break;
				case MOUNTAIN:
					this->rectangle[i][j].cost = costGround.mountain;
					break;
				case EARTH:
					this->rectangle[i][j].cost = costGround.earth;
					break;
				case SWAMP:
					this->rectangle[i][j].cost = costGround.swamp;
					break;
				case WATER:
					this->rectangle[i][j].cost = costGround.water;
					break;
			}//end case
		}//end for j
	}//end for i
}//end Tray_set_cost

void free_tray(Tray *this) {
	int i;
	for (i=0; i < this->columns; i++)
	{
		free(this->rectangle[i]);
	}
	free(this->rectangle);
	
	free(this);
}//end free_tray
