#ifndef TRAYMAP_H
#define TRAYMAP_H

#include <stdio.h>

#define SIZE_MAP 128

/* Used by Map and Tray
 * Contain ASCII code of map
 * Contain Map of Cumul Cost
 * */
typedef  char ArrayMapASCII[SIZE_MAP][SIZE_MAP];
typedef double ArrayMapCumulCost[SIZE_MAP][SIZE_MAP];

/* Used by Unit and Tray
 * if cost is low the Unit can move on the long distance
 * if cost is hight the Unit move on the short distance
 * For example : if earth=1, mountain=2 and total_cost=10
 * The unit move 10 divisions on earth and 5 divisions on mountain (total_cost/earth and total_cost/mountain)
 * Value must equal 0 if Unit can't occupy division (obstacle ...)
 * */
typedef struct {
	int obstacle;
	int earth;
	int mountain;
	int swamp;
	int water;
	int total_cost;
} CostGround;

void TrayMapUnit_display_array_map_cumul_cost(ArrayMapCumulCost arrayMapCumulCost, int nbCol, int nbRow);
//void TrayMapUnit_display_possible_displacement_SDL(ArrayMapCumulCost arrayMapCumulCost, int nbCol, int nbRow);
#endif //TRAYMAP_H
