#include "Unit.h"

Unit *new_unit() {
	Unit *this;
	this = (Unit*) malloc(sizeof(Unit));
	if ( sizeof("../images/select.bmp") >= SIZE_PATH) {
		printf("In Constructor of Unit.c : Src select.bmp is too big for Dest\n");
	} else {
		strcpy(this->imageSelect, "../images/select.bmp");
	}
	this->stepMove = 8;// you must choose beetwen 2, 4, 8, 16 or 32
	this->state = IMMOBILE;
	this->direction = E;
	return this;
}//end constructor generic

Unit *new_unit_with_file(char imageBMP[SIZE_PATH], char sound[SIZE_PATH],
				int column, int line)
{
    Unit *this;
    
    this = (Unit*) malloc(sizeof(Unit));
	strcpy(this->imageBMP,  imageBMP);
	strcpy(this->soundWAV, sound);
	if ( sizeof("../images/select.bmp") >= SIZE_PATH) {
		printf("In Constructor of Unit.c : Src select.bmp is too big for Dest\n");
	} else {
		strcpy(this->imageSelect, "../images/select.bmp");
	}
	this->column = column;
	this->line = line;
	this->x = column*SIZE_UNIT_BMP;
	this->y = line*SIZE_UNIT_BMP;
	this->stepMove = 8; // you must choose beetwen 2, 4, 8, 16 or 32
	this->state = IMMOBILE;
	this->direction = E;
    return this;
}//end constructor Unit

void Unit_display_cost_unit(Unit *unit) {
	printf("Cost unit\n");
	printf("Obstacle : %d \t Earth : %d \t Mountain : %d \t Swamp : %d \t Water : %d\n",
		unit->costGround.obstacle, unit->costGround.earth,
		unit->costGround.mountain,
		unit->costGround.swamp, unit->costGround.water);
}

Direction Unit_get_set_direction(Unit *this, int mouse_x, int mouse_y) {
	Direction direction;
	int col_mouse, line_mouse;
	
	col_mouse = (int) (mouse_x / SIZE_UNIT_BMP);
	line_mouse = (int) (mouse_y / SIZE_UNIT_BMP);
	/*
	// same position
	if ( col_mouse == this->column && line_mouse == this->line ) {
		direction = this->directionBMP;
	}
	*/
	//left position
	if ( col_mouse < this->column && line_mouse == this->line ) {
		this->direction = W; //save position in case there is no motion
	}
	
	//left upper position
	if ( col_mouse < this->column && line_mouse < this->line ) {
		this->direction = NW;
	}
	
	// upper position
	if ( col_mouse == this->column && line_mouse < this->line ) {
		this->direction = N;
	}
	
	//right upper position
	if ( col_mouse > this->column && line_mouse < this->line ) {
		this->direction = NE;
	}
	
	//right position
	if ( col_mouse > this->column && line_mouse == this->line ) {
		this->direction = E;
	}
	
	//right lower position
	if ( col_mouse > this->column && line_mouse > this->line ) {
		this->direction = SE;
	}
	
	// lower position
	if ( col_mouse == this->column && line_mouse > this->line ) {
		this->direction = SW;
	}
	
	// left lower position
	if ( col_mouse < this->column && line_mouse > this->line ) {
		this->direction = SW;
	}
	return this->direction;
}//end Unit_get_direction

void Unit_display_unit_SDL(Unit *this, SDL_Renderer *renderer)
{
	SDL_Surface *s_unit;
	SDL_Texture *texture;
//	SDL_Rect Src, Dest;
	s_unit = SDL_LoadBMP(this->imageBMP);
	
	if (s_unit) {
		SDL_Rect Src, Dest;
		switch (this->direction) {
			case W:
				this->directionBMP = 0;
				break;
			case NW:
				this->directionBMP = 1*SIZE_UNIT_BMP;
				break;
			case N:
				this->directionBMP = 2*SIZE_UNIT_BMP;
				break;
			case NE:
				this->directionBMP = 3*SIZE_UNIT_BMP;
				break;
			case E:
				this->directionBMP = 4*SIZE_UNIT_BMP;
				break;
			case SE:
				this->directionBMP = 5*SIZE_UNIT_BMP;
				break;
			case S:
				this->directionBMP = 6*SIZE_UNIT_BMP;
				break;
			case SW:
				this->directionBMP = 7*SIZE_UNIT_BMP;
				break;
		}//end switch
		
		printf("Chargement d'image %s\n", this->imageBMP);
		SDL_SetColorKey(s_unit, SDL_TRUE, SDL_MapRGB(s_unit->format, 255, 255, 255));
		texture = SDL_CreateTextureFromSurface(renderer, s_unit);
		
//		printf("Information Unit.c (Unit_display_unit_SDL):\n x=%i \t y=%i\n", this->x, this->y);
		Src.w = SIZE_UNIT_BMP;
		Src.h = SIZE_UNIT_BMP;
		Dest.w = SIZE_UNIT_BMP;
		Dest.h = SIZE_UNIT_BMP;
		Dest.x = this->x;
		Dest.y = this->y;
		Src.x = this->directionBMP;
		Src.y = 0;
	
		if (this->state == SELECTED) {
						printf("Select Unit\n");
		SDL_Surface *select;
		SDL_Texture *textureSelect;
		SDL_Rect Src_s;
		select = SDL_LoadBMP(this->imageSelect);
			if (select) {
//			printf("Chargement d'image %s\n", this->imageSelect);
			SDL_SetColorKey(select, SDL_TRUE, SDL_MapRGB(select->format, 255, 255, 255));
			textureSelect = SDL_CreateTextureFromSurface(renderer, select);
			Src_s.x=0;
			Src_s.y=0;
			Src_s.w = SIZE_UNIT_BMP;
			Src_s.h = SIZE_UNIT_BMP;
			SDL_RenderCopy(renderer, textureSelect, &Src_s, &Dest);
						
			SDL_DestroyTexture(textureSelect);
			SDL_FreeSurface(select);

			} else {
				printf("Error load select's image %s\n", this->imageSelect);
			}
		}//end if state Select

		SDL_RenderCopy(renderer, texture, &Src, &Dest);
		
	}//end_if s_unit
	
	SDL_DestroyTexture(texture);	
	SDL_FreeSurface(s_unit);
}//end Unit_display_unit_SDL

void Unit_display_unit_SDL_with_direction(Unit *this, SDL_Renderer *renderer, Direction direction)
{
	SDL_Surface *s_unit;
	SDL_Texture *texture;
//	SDL_Rect Src, Dest;
	s_unit = SDL_LoadBMP(this->imageBMP);
	
	if (s_unit) {
		SDL_Rect Src, Dest;
		switch (direction) {
			case W:
				this->directionBMP = 0;
				break;
			case NW:
				this->directionBMP = 1*SIZE_UNIT_BMP;
				break;
			case N:
				this->directionBMP = 2*SIZE_UNIT_BMP;
				break;
			case NE:
				this->directionBMP = 3*SIZE_UNIT_BMP;
				break;
			case E:
				this->directionBMP = 4*SIZE_UNIT_BMP;
				break;
			case SE:
				this->directionBMP = 5*SIZE_UNIT_BMP;
				break;
			case S:
				this->directionBMP = 6*SIZE_UNIT_BMP;
				break;
			case SW:
				this->directionBMP = 7*SIZE_UNIT_BMP;
				break;
		}//end switch
		
		printf("Chargement d'image %s\n", this->imageBMP);
		SDL_SetColorKey(s_unit, SDL_TRUE, SDL_MapRGB(s_unit->format, 255, 255, 255));
		texture = SDL_CreateTextureFromSurface(renderer, s_unit);
		
//		printf("Information Unit.c (Unit_display_unit_SDL):\n x=%i \t y=%i\n", this->x, this->y);
		Src.w = SIZE_UNIT_BMP;
		Src.h = SIZE_UNIT_BMP;
		Dest.w = SIZE_UNIT_BMP;
		Dest.h = SIZE_UNIT_BMP;
		Dest.x = this->x;
		Dest.y = this->y;
		Src.x = this->directionBMP;
		Src.y = 0;
	
		if (this->state == SELECTED) {
						printf("Select Unit\n");
		SDL_Surface *select;
		SDL_Texture *textureSelect;
		SDL_Rect Src_s;
		select = SDL_LoadBMP(this->imageSelect);
			if (select) {
//			printf("Chargement d'image %s\n", this->imageSelect);
			SDL_SetColorKey(select, SDL_TRUE, SDL_MapRGB(select->format, 255, 255, 255));
			textureSelect = SDL_CreateTextureFromSurface(renderer, select);
			Src_s.x=0;
			Src_s.y=0;
			Src_s.w = SIZE_UNIT_BMP;
			Src_s.h = SIZE_UNIT_BMP;
			SDL_RenderCopy(renderer, textureSelect, &Src_s, &Dest);
						
			SDL_DestroyTexture(textureSelect);
			SDL_FreeSurface(select);

			} else {
				printf("Error load select's image %s\n", this->imageSelect);
			}
		}//end if state Select

		SDL_RenderCopy(renderer, texture, &Src, &Dest);
		
	}//end_if s_unit
	
	SDL_DestroyTexture(texture);	
	SDL_FreeSurface(s_unit);
}//end Unit_display_unit_SDL

void free_unit(Unit *this) {
	free(this);
}//end free_unit

