#ifndef UNIT_H
#define UNIT_H

#include <SDL2/SDL.h>
#include <string.h>

#include "../src/Global.h"
#include "../src/TrayMapUnit.h"

#define SIZE_UNIT_BMP 32
//#define SIZE_PATH 80

typedef enum {SELECTED, MOVING, IMMOBILE} UnitState;

/* Direction of unit. W is west, NW is North West etc ... */
typedef enum {W, NW, N, NE, E, SE, S, SW} Direction;

typedef struct {
    int column;
    int line;
	int x;
	int y;
	int next_x;
	int next_y;
	int end_pos_x;
	int end_pos_y;
	Direction direction;
    int directionBMP; // left | left upper | upper ...
    char codeASCII;
    char imageBMP[SIZE_PATH];
	char soundWAV[SIZE_PATH];
	char imageSelect[SIZE_PATH];
	int stepMove; //2 | 4 | 8 | 16 | 32
	UnitState state;
	CostGround costGround;	// defined in TrayMapUnit.h
//	ArrayMapCumulCost arrayMapCumulCost;	// defined in TrayMapUnit.h
}Unit;

Unit *new_unit();
Unit *new_unit_with_file(char image[SIZE_PATH], char sound[SIZE_PATH], int column, int line);
void Unit_display_cost_unit(Unit *unit);
Direction Unit_get_set_direction(Unit *unit, int mouse_x, int mouse_y);
void Unit_display_unit_SDL(Unit *unit, SDL_Renderer *renderer);
void Unit_display_unit_SDL_with_direction(Unit *unit, SDL_Renderer *renderer, Direction direction);
void free_unit(Unit *unit);
#endif //UNIT_H
