#include <SDL2/SDL.h>
#include "../Map.h"

int main() {
	SDL_Window *window;
	    SDL_Renderer *renderer;

	SDL_Event event;
	int quit=0;
Map *map = new_map("../images/Map2.bmp", "../map/Map2.txt");
	int res = Map_load_map(map);
	
	if (SDL_VideoInit(NULL) < 0) {
		SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't initialize SDL video: %s\n",
                SDL_GetError());
        exit(1);
	}
	
	window = SDL_CreateWindow("Fenetre", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED,
	                          800, 640, SDL_WINDOW_SHOWN);

	 renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);

	Map_display_map_SDL(map, renderer);
		SDL_RenderPresent(renderer);

	while ( !quit ) {
		if ( SDL_PollEvent(&event) ) {
			switch (event.type) {
				case SDL_QUIT:
					quit=1;
					break;
			}//end switch event.type
		}//end if PollEvent
	}//end while quit
	
	SDL_DestroyWindow(window);
	SDL_Quit();
	return 0;
}
