#include <SDL2/SDL.h>
#include "../src/Scene.h"

int main() {
	SDL_Window *window;
	    SDL_Renderer *renderer;

	SDL_Event event;
	int quit=0;
	int resultUnit=-1;
	
	if (SDL_VideoInit(NULL) < 0) {
		SDL_LogError(SDL_LOG_CATEGORY_APPLICATION, "Couldn't initialize SDL video: %s\n",
                SDL_GetError());
        exit(1);
	}
	
	window = SDL_CreateWindow("Fenetre", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED,
	                          800, 640, SDL_WINDOW_SHOWN);

	 renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);
	 
	printf("Create Scene\n");
	Scene *scene;
	scene = new_scene(renderer);
	printf("Load scenario\n");
	Scene_load_scene(scene, "../scenario/Scenario1.txt");
	Scene_display_files(scene);

	SDL_RenderPresent(renderer);

	while ( !quit ) {
		if ( SDL_PollEvent(&event) ) {
			switch (event.type) {
				case SDL_QUIT:
					quit=1;
					break;
					
				case SDL_MOUSEBUTTONDOWN:
					switch (event.button.button) {
						case SDL_BUTTON_LEFT:
							resultUnit = Scene_is_unit(scene, event.motion.x, event.motion.y);
							if (resultUnit != -1) { //if is unit
								printf("Selection Unite\n");
								Scene_change_select_unit(scene, scene->numberSelectedUnit, resultUnit);
							} else {
								printf("Pas de selection\n");
							}//end if resultUnit
						break; //BUTTON_LEFT
					}//end switch event.button
			}//end switch event.type
		}//end if PollEvent
	}//end while quit
	
	free_scene(scene);
	SDL_DestroyWindow(window);
	SDL_Quit();
	return 0;
}
